// PalmMatch.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "..\..\lib\MinuCode.h"

void CreateMinuCode(char* sFeaturePath, char* title);
MatchInfo Match(char* path1, char* path2, char* title1, char* title2);

// These two parameters need to be set by the caller
bool g_bPartial2Full = false;// true for partial-to-full match, false for full-to-full match
int g_nMaxRotation = 70;// maximum rotation angle between two palmprints, 180 means that any rotation is possible

void DoSingle()
{
	char path1[MAX_PATH] = "Y:\\Jianjiang\\mypaper\\Published\\PAMI_Palm\\code\\SDK\\feature\\";
	char path2[MAX_PATH] = "Y:\\Jianjiang\\mypaper\\Published\\PAMI_Palm\\code\\SDK\\feature\\";
	char title1[MAX_PATH] = "a";
	char title2[MAX_PATH] = "b";
	CreateMinuCode(path1, title1);// this can be done during enrollment stage to save time
	CreateMinuCode(path2, title2);
	MatchInfo result = Match(path1, path2, title1, title2);
	printf("%6.3f\n", result.score);
}

// Create MinutiaCode for palmprints in PV-TEST. This can be done during enrollment stage to save time
void DoBatCreateCode_PV_TEST()
{
	for(int i = 1; i <= 10; i++)
	{
		for(int j = 1; j <= 8; j++)
		{
			char sTitle[MAX_PATH];
			sprintf(sTitle, "T%02d_F%d", i, j);
			printf("Create MinuCode for %s...", sTitle);
			CreateMinuCode("F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\", sTitle);
			printf("OK.\n");
		}
	}
}

// Genuine matches on PV-TEST dataset
void DoBatMatchGenuine_PV_TEST()
{
	char path1[MAX_PATH] = "F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\";
	char path2[MAX_PATH] = "F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\";
	char title1[MAX_PATH], title2[MAX_PATH];
	FILE* file = fopen("F:\\data\\PVC\\PV-TEST2\\match\\MatchFull_genuine_log_v0.1_v0.1.txt", "wb");
	for(int i = 1; i <= 10; i++)
	{
		for(int j = 1; j <= 7; j++)
		{
			for(int k = j+1; k <= 8; k++)
			{
				sprintf(title1, "T%02d_F%d", i, j);
				sprintf(title2, "T%02d_F%d", i, k);
				printf("Match %s to %s ...", title1, title2);
				MatchInfo result = Match(path1, path2, title1, title2);
				printf("%6.3f\n", result.score);
				fprintf(file, "%s %s OK %6.3f\r\n", title1, title2, result.score);
			}
		}
	}
	fclose(file);
}

// Impstor matches on PV-TEST dataset
void DoBatMatchImpostor_PV_TEST()
{
	char path1[MAX_PATH] = "F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\";
	char path2[MAX_PATH] = "F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\";
	char title1[MAX_PATH], title2[MAX_PATH];
	FILE* file = fopen("F:\\data\\PVC\\PV-TEST2\\match\\MatchFull_impostor_log_v0.1_v0.1.txt", "wb");
	for(int i = 1; i <= 9; i++)
	{
		for(int j = i+1; j <= 10; j++)
		{
			sprintf(title1, "T%02d_F%d", i, 1);
			sprintf(title2, "T%02d_F%d", j, 1);
			printf("Match %s to %s ...", title1, title2);
			MatchInfo result = Match(path1, path2, title1, title2);
			printf("%6.3f\n", result.score);
			fprintf(file, "%s %s OK %6.3f\r\n", title1, title2, result.score);
		}
	}
	fclose(file);
}

int main(int argc, char* argv[])
{
	// Do a single match
	// DoSingle();

	// Do a bat match
	DoBatCreateCode_PV_TEST();
	DoBatMatchGenuine_PV_TEST();
	DoBatMatchImpostor_PV_TEST();

	return 0;
}

