#ifndef _MIXARRAY_H_
#define _MIXARRAY_H_

template <typename T>
struct EasyMixArray
{
	T* p;
	T** pp;
	int nHeight;
	int nWidth;
};

template <typename T>
EasyMixArray<T>* CreateMixArray(int nHeight, int nWidth)
{
	EasyMixArray<T>* pma = new EasyMixArray<T>;
	pma->nHeight = nHeight;
	pma->nWidth = nWidth;
	pma->p = new T[nHeight * nWidth];
	pma->pp = new T*[nHeight];
	for(int row = 0; row < nHeight; ++row)
		pma->pp[row] = pma->p + row * nWidth;
	return pma;
}

template <typename T>
void ReleaseMixArray(EasyMixArray<T>** ppma)
{
	if((*ppma) == 0)
		return;
	delete[] (*ppma)->p;
	delete[] (*ppma)->pp;
	delete (*ppma);
	(*ppma) = 0;
}

template <typename T>
EasyMixArray<T>* CloneMixArray(EasyMixArray<T>* src)
{
	EasyMixArray<T>* dst = CreateMixArray<T>(src->nHeight, src->nWidth);
	memcpy(dst->p, src->p, sizeof(T)*src->nHeight*src->nWidth);
	return dst;
}


#endif
