//*================================================================================================
//SingleFingerMatch.h match dynamic link library header file
//constants defination, struct definations, and functions declaration
//all rights reserved (c) 2001.09.25
//===============================================================================================*/

#ifndef _CONSTANT_
#define _CONSTANT_

	#define PAI				 3.141592653589793
	#define HPAI			 1.570796326794897
	#define DPAI			 6.283185307179586	//@. = 2*PAI			
	#define NPAI           3.141592653589793

	#define ATR				 0.017453292519943	//@. = PAI/180 
	#define RTA				57.295779513082321	//@. = 180/PAI

	#define MINU_CONFIDENCE_MANUAL_EXTRACTED 0	//@. ˹ȡ
	#define MINU_CONFIDENCE_AUTO_EXTRACTED	 1	//@. ԶȡûŶ
	#define MINU_CONFIDENCE_MAX				 2	//@. ԶȡŶ(εݼ)
	#define MINU_CONFIDENCE_MIN				 8	//@. ԶȡŶС(εݼ)
	#define MINU_CONFIDENCE_INVALIDATION	 9	//@. Ч,

	#define MAX_MINU_COUNT				   80	//@, Ŀ

#endif	//#ifndef _CONSTANT_

#ifndef _MATCH_CORE_
#define _MATCH_CORE_

	typedef struct  _Match_MinutiaeInfo
	{
		int					iSita;						//@. Ƕ
		int					ix;							//@. 	
		int					iy;							//@. 
	}MATCH_MINUINFO;		

	typedef struct  _Match_CenterInfo
	{
		int					cFid;						//@. Ŷ
		int					cx;							//@. 
		int					cy;							//@. 
		int					cSita;						//@. ķ
		int					cRAngle;					//@. Ƕ(һ)
		int					cRadius;					//@. 뾶
	}MATCH_CENTERINFO;

	typedef struct  _Match_DeltaInfo
	{
		int					dFid;						//@. Ŷ
		int					dx;							//@. 
		int					dy;							//@. 
	}MATCH_DELTAINFO;

	typedef struct  _Match_DataInfo
	{
		int					mNum;						//@. Ŀ
		MATCH_CENTERINFO	mCen;						//@. Ϣ
		MATCH_DELTAINFO		mDelta[2];					//@. Ϣ
		MATCH_MINUINFO		mMinu[MAX_MINU_COUNT];		//@. Ϣ
	}MATCH_DATAINFO;

	typedef struct _Match_ResultInfo
	{
		int					iNum;						//@. ƥ
		int					iScore;						//@. ƥķ
		int					mSeq[MAX_MINU_COUNT];		//@. ֳѽƥϵ(ƥȺ˳)
		int					nSeq[MAX_MINU_COUNT];		//@. ѽƥϵ(ƥȺ˳),һһӦ
		int					mFlg[MAX_MINU_COUNT];		//@. ֳǷƥı־ 0--δƥ䣻1--ƥ  ṹе˳
		int					nFlg[MAX_MINU_COUNT];		//@. Ƿƥı־ 0--δƥ䣻1--ƥ 
	}MATCH_RESULTINFO;

#endif	//#ifndef _MATCH_CORE_  


//Afis system needed structure
#ifndef _AFIS_CORE_
#define _AFIS_CORE_

	//AFIS DB еݽṹ
	typedef struct _Afis_LSearch
	{
		unsigned char	id[10];
		unsigned char	chN;
		unsigned char	chX[150];
		unsigned char	chY[150];
		short			shD[150];
		unsigned char	chNmbLine[150][2];
		unsigned char	chNRectangle;
		unsigned char	chRctXMin[10];		
		unsigned char	chRctYMin[10];
		unsigned char	chRctXMax[10];
		unsigned char	chRctYMax[10];
		char			chFinger[10];
		char			chPattern[6];
		char			chCoreDistanceR;
		char			chCoreAngleR;
		char			chTenFingerPattern[10];
	}AFIS_LATENT;

	typedef struct _Afis_Tenprint
	{
		long int		WID;
		short			MinuNum;      
		short			chX[150];
		short			chY[150];
		short			shD[150];
		BYTE			chNmbLine[150];
	}AFIS_TENPRINT;

	//NIST DB е
	typedef struct _NistLSearch
	{
		unsigned char	id[10];				//WID
		unsigned char	chN;				//the number of the core & minu
		unsigned int	chX[150];			//0-core;1~145-minu;145~147-delta
		unsigned int	chY[150];
		unsigned int	shD[150];
		unsigned char	chNmbLine[150][2];	// useless now
		unsigned char	chNRectangle;		// the number of clear_area
		unsigned char	chRctXMin[10];		
		unsigned char	chRctYMin[10];
		unsigned char	chRctXMax[10];
		unsigned char	chRctYMax[10];
		char			chFinger[10];		// finger position
		char			chPattern[6];		//finger type
		char			chCoreDistanceR;
		char			chCoreAngleR;
		char			chTenFingerPattern[10];		//reserve
	}NIST_LATENT;	
	#define NIST_TENPRINT	NIST_LATENT

	//LIVE DB е
	#define LIVE_MAX_MINU_COUNT		80

	typedef struct  _Live_MinutiaeInfo
	{
		unsigned char	iSita;
		short	ix;	
		unsigned short	iy;
	}LIVE_MINUINFO;

	typedef struct  _Live_CenterInfo
	{
		unsigned char	cFid;					//@. Ŷ
		short	cx;								//@. 
		unsigned short	cy;						//@. 
		unsigned short	cSita;					//@. ķ
	}LIVE_CENTERINFO;

	typedef struct  _Live_LatentInfo
	{
		unsigned char	mNum;						//@. Ŀ
		LIVE_CENTERINFO	mCen;
		LIVE_MINUINFO   mMinu[LIVE_MAX_MINU_COUNT];	//@. Ϣ
	}LIVE_LATENT;

	#define LIVE_TENPRINT LIVE_LATENT

#endif	//#ifndef _AFIS_CORE_  
